# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://docs.scrapy.org/en/latest/topics/item-pipeline.html


# useful for handling different item types with a single interface
from itemadapter import ItemAdapter
import scrapy
import requests
import os
from PIL import Image
from io import BytesIO
from pathlib import Path

class TrPipeline:
    # 自定义管道下载图片
    def process_item(self, item, spider):
        # 获取图片资源内容
        response = requests.get(item['image_urls'][0])
        image = Image.open(BytesIO(response.content))
        # 保存路径
        pathname = "/Volumes/D/pythonProject/tr.lol.qq.com/imgs/"+str(item['image_class'])+"/"
        # 如果路径不存在则创建
        dir = Path(pathname)
        if dir.exists() == False:
            os.makedirs(pathname) # 版本低一点的python，用mkdirs
        # 图片名称
        imgname = str(abs(hash(item['image_urls'][0])))+'.jpg'

        # 判断图片是否存在，存在则不再保存
        imgexist = Path(pathname+imgname)
        if imgexist.exists() == False:
            # 保存到本地
            image.save(pathname+imgname)

        return item