import scrapy
from selenium import webdriver
from tr.items import TrItem
import re
# 抓取lol完结创作图片 - 特点：列表页瀑布流动态加载
class TrpicSpider(scrapy.Spider):
    name = 'trpic'
    allowed_domains = ['tr.lol.qq.com']
    start_urls = ['https://tr.lol.qq.com/']

    def __init__(self):
        self.browser = webdriver.Chrome("/usr/bin/chromedriver")

    def parse(self, response):
        # 获取详情页地址
        for urlpath in response.css("div.flow-item>a::attr(href)").getall():
            detailUrl = response.urljoin(urlpath)
            yield scrapy.Request(detailUrl,callback=self.parse_detail)

    # 解析详情页
    def parse_detail(self, response):
        image_class = response.css("p#map>a:last-child::text").get()
        for each in response.css("div.article-cont img"):
            item = TrItem()
            imgs = []
            for img in each.css("::attr(src)").getall():
                imgurl = img
                # 判断图片是不是http开头
                if re.match('http',imgurl) == None:
                    imgurl = 'http:'+imgurl
                imgs.append(imgurl)
            item['image_urls'] = imgs
            item['image_class'] = image_class
            yield item